<?php
$api_info = array(
  'ajax' => array(
    'desc' => 'The jQuery4PHP library has a full suite of AJAX capabilities. The functions and methods therein allow us to load data from the server without a browser page refresh. ',
    'ajax' => array(
      'desc' => 'Attach a handler to an event for the elements.',
      'realLink' => 'ajax'
    ),
    'ajaxComplete' => array(
      'desc' => 'Register a handler to be called when Ajax requests complete. This is an Ajax Event. ',
      'realLink' => 'ajaxComplete'
    ),
    'ajaxError' => array(
      'desc' => 'Register a handler to be called when Ajax requests complete. This is an Ajax Event. ',
      'realLink' => 'ajaxError'
    ),
    'ajaxSend' => array(
      'desc' => 'Show a message before an Ajax request is sent. ',
      'realLink' => 'ajaxSend'
    ),
    'ajaxSetup' => array(
      'desc' => 'Set default values for future Ajax requests. ',
      'realLink' => 'jQuery.ajaxSetup'
    ),
    'ajaxStart' => array(
      'desc' => 'Register a handler to be called when Ajax requests complete. This is an Ajax Event. ',
      'realLink' => 'ajaxStart'
    ),
    'ajaxStop' => array(
      'desc' => 'Hide a loading message after all the Ajax requests have stopped. ',
      'realLink' => 'ajaxStop'
    ),
    'ajaxSuccess' => array(
      'desc' => 'Show a message when an Ajax request completes successfully. ',
      'realLink' => 'ajaxSuccess'
    ),
    'get' => array(
      'desc' => 'Load data from the server using a HTTP GET request. ',
      'realLink' => 'jQuery.get'
    ),
    'getJSON' => array(
      'desc' => 'Load JSON-encoded data from the server using a GET HTTP request. ',
      'realLink' => 'jQuery.getJSON'
    ),
    'getScript' => array(
      'desc' => 'Load a JavaScript file from the server using a GET HTTP request, then execute it. ',
      'realLink' => 'jQuery.getScript'
    ),
    'load' => array(
      'desc' => 'Load data from the server and place the returned HTML into the matched element. ',
      'realLink' => 'load'
    ),
    'param' => array(
      'desc' => 'Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request. ',
      'realLink' => 'jQuery.param()'
    ),
    'post' => array(
      'desc' => 'Load data from the server using a HTTP POST request. ',
      'realLink' => 'jQuery.post'
    ),
    'serialize' => array(
      'desc' => 'Encode a set of form elements as a string for submission. ',
      'realLink' => 'serialize'
    ),
    'serializeArray' => array(
      'desc' => 'Encode a set of form elements as an array of names and values. ',
      'realLink' => 'serializeArray'
    )
  ),
  'effects' => array(
    'desc' => 'The jQuery4PHP library provides several techniques for adding animation to a web page. These include simple, standard animations that are frequently used, and the ability to craft sophisticated custom effects. In this chapter, we’ll closely examine each of the effect methods, revealing all of the mechanisms jQuery4PHP has for providing visual feedback to the user.',
    'animate' => array(
      'desc' => 'Perform a custom animation of a set of CSS properties. ',
      'realLink' => 'animate'
    ),
    'clearQueue' => array(
      'desc' => 'Remove from the queue all items that have not yet been run. ',
      'realLink' => 'clearQueue'
    ),
    'delay' => array(
      'desc' => 'Set a timer to delay execution of subsequent items in the queue. ',
      'realLink' => 'delay'
    ),
    'dequeue' => array(
      'desc' => 'Execute the next function on the queue for the matched elements. ',
      'realLink' => 'dequeue'
    ),
    'fadeIn' => array(
      'desc' => 'Display the matched elements by fading them to opaque. ',
      'realLink' => 'fadeIn'
    ),
    'fadeOut' => array(
      'desc' => 'Hide the matched elements by fading them to transparent. ',
      'realLink' => 'fadeOut'
    ),
    'fadeTo' => array(
      'desc' => 'Adjust the opacity of the matched elements. ',
      'realLink' => 'fadeTo'
    ),
    'hide' => array(
      'desc' => 'Hide the matched elements. ',
      'realLink' => 'hide'
    ),
    'queue' => array(
      'desc' => 'Show the queue of functions to be executed on the matched elements. ',
      'realLink' => 'queue'
    ),
    'show' => array(
      'desc' => 'Display the matched elements. ',
      'realLink' => 'show'
    ),
    'slideDown' => array(
      'desc' => 'Display the matched elements with a sliding motion. ',
      'realLink' => 'slideDown'
    ),
    'slideToggle' => array(
      'desc' => 'Display or hide the matched elements with a sliding motion. ',
      'realLink' => 'slideToggle'
    ),
    'slideUp' => array(
      'desc' => 'Hide the matched elements with a sliding motion. ',
      'realLink' => 'slideUp'
    ),
    'stop' => array(
      'desc' => 'Stop the currently-running animation on the matched elements. ',
      'realLink' => 'stop'
    ),
    'toggle' => array(
      'desc' => 'Bind two or more handlers to the matched elements, to be executed on alternate clicks.',
      'realLink' => 'toggle'
    )
  ),
  'events' => array(
    'desc' => 'These methods are used to register behaviors to take effect when the user interacts with the browser, and to further manipulate those registered behaviors.',
    'bind' => array(
      'desc' => 'Attach a handler to an event for the elements. ',
      'realLink' => 'bind'
    ),
    'blur' => array(
      'desc' => 'Bind an event handler to the "blur" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'blur'
    ),
    'change' => array(
      'desc' => 'Bind an event handler to the "change" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'change'
    ),
    'click' => array(
      'desc' => 'Bind an event handler to the "click" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'click'
    ),
    'dblclick' => array(
      'desc' => 'Bind an event handler to the "dblclick" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'dblclick'
    ),
    'delegate' => array(
      'desc' => 'Attach a handler to one or more events for all elements that match the selector, now or in the future, based on a specific set of root elements. ',
      'realLink' => 'delegate'
    ),
    'die' => array(
      'desc' => 'Remove all event handlers previously attached using .live() from the elements. ',
      'realLink' => 'die'
    ),
    'error' => array(
      'desc' => 'Bind an event handler to the "error" JavaScript event.',
      'realLink' => 'error'
    ),
    'focus' => array(
      'desc' => 'Bind an event handler to the "focus" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'focus'
    ),
    'focusout' => array(
      'desc' => 'Bind an event handler to the "focusout" JavaScript event. ',
      'realLink' => 'focusout'
    ),
    'hover' => array(
      'desc' => 'Bind two handlers to the matched elements, to be executed when the mouse pointer enters and leaves the elements. ',
      'realLink' => 'hover'
    ),
    'keydown' => array(
      'desc' => 'Bind an event handler to the "keydown" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'keydown'
    ),
    'keypress' => array(
      'desc' => 'Bind an event handler to the "keypress" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'keypress'
    ),
    'keyup' => array(
      'desc' => 'Bind an event handler to the "keyup" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'keyup'
    ),
    'live' => array(
      'desc' => 'Attach a handler to the event for all elements which match the current selector, now or in the future. ',
      'realLink' => 'live'
    ),
    'load' => array(
      'desc' => 'Bind an event handler to the "load" JavaScript event. ',
      'realLink' => 'load'
    ),
    'mousedown' => array(
      'desc' => 'Bind an event handler to the "mousedown" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'mousedown'
    ),
    'mouseenter' => array(
      'desc' => 'Bind an event handler to be fired when the mouse leaves an element, or trigger that handler on an element.',
      'realLink' => 'mouseenter'
    ),
    'mousemove' => array(
      'desc' => 'Bind an event handler to the "mousemove" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'mousemove'
    ),
    'mouseout' => array(
      'desc' => 'Bind an event handler to the "mouseout" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'mouseout'
    ),
    'mouseover' => array(
      'desc' => 'Bind an event handler to the "mouseover" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'mouseover'
    ),
    'mouseup' => array(
      'desc' => 'Bind an event handler to the "mouseup" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'mouseup'
    ),
    'one' => array(
      'desc' => 'Attach a handler to an event for the elements. The handler is executed at most once. ',
      'realLink' => 'one'
    ),
    'proxy' => array(
      'desc' => 'Takes a function and returns a new one that will always have a particular context. ',
      'realLink' => 'proxy'
    ),
    'ready' => array(
      'desc' => 'Specify a function to execute when the DOM is fully loaded. ',
      'realLink' => 'ready'
    ),
    'scroll' => array(
      'desc' => 'Bind an event handler to the "scroll" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'scroll'
    ),
    'select' => array(
      'desc' => 'Bind an event handler to the "select" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'select'
    ),
    'submit' => array(
      'desc' => 'Bind an event handler to the "submit" JavaScript event, or trigger that event on an element. ',
      'realLink' => 'keypress'
    ),
    'toggle' => array(
      'desc' => 'Bind two or more handlers to the matched elements, to be executed on alternate clicks. ',
      'realLink' => 'toggle'
    ),
    'trigger' => array(
      'desc' => 'Execute all handlers and behaviors attached to the matched elements for the given event type. ',
      'realLink' => 'trigger'
    ),
    'triggerHandler' => array(
      'desc' => 'Execute all handlers attached to an element for an event. ',
      'realLink' => 'triggerHandler'
    ),
    'unbind' => array(
      'desc' => 'Remove a previously-attached event handler from the elements. ',
      'realLink' => 'unbind'
    ),
    'undelegate' => array(
      'desc' => 'Remove a previously-attached event handler from the elements. ',
      'realLink' => 'undelegate'
    ),
    'unload' => array(
      'desc' => 'Bind an event handler to the "unload" JavaScript event. ',
      'realLink' => 'unload'
    )
  ),
  'manipulation' => array(
    'desc' => 'All of the methods in this chapter manipulate the DOM in some manner. A few of them simply change one of the attributes of an element (also listed in the
              <a href="http://api.jquery.com/category/attributes/">Attributes category</a>
              ), while others set an element’s style properties (also listed in the
              <a href="http://api.jquery.com/category/css/">CSS category</a>
              ). Still others modify entire elements (or groups of elements) themselves—inserting, copying, removing, and so on. All of these methods are referred to as “setters,” as they change the values of properties.
              <br/>
              A few of these methods—such as
              <code>.attr()</code>
              ,
              <code>.html()</code>
              , and
              <code>.val()</code>
              —also act as “getters,” retrieving information from DOM elements for later use.',
    'addClass' => array(
      'desc' => 'Adds the specified class(es) to each of the set of matched elements. ',
      'realLink' => 'addClass'
    ),
    'after' => array(
      'desc' => 'Insert content, specified by the parameter, after each element in the set of matched elements. ',
      'realLink' => 'after'
    ),
    'append' => array(
      'desc' => 'Insert content, specified by the parameter, to the end of each element in the set of matched elements. ',
      'realLink' => 'append'
    ),
    'appendTo' => array(
      'desc' => 'Insert every element in the set of matched elements to the end of the target. ',
      'realLink' => 'appendTo'
    ),
    'attr' => array(
      'desc' => 'Get the value of an attribute for the first element in the set of matched elements. ',
      'realLink' => 'attr'
    ),
    'before' => array(
      'desc' => 'Insert content, specified by the parameter, before each element in the set of matched elements. ',
      'realLink' => 'before'
    ),
    'clone' => array(
      'desc' => 'Create a copy of the set of matched elements. ',
      'realLink' => 'clone'
    ),
    'css' => array(
      'desc' => 'Get the value of a style property for the first element in the set of matched elements. ',
      'realLink' => 'css'
    ),
    'detach' => array(
      'desc' => 'Remove the set of matched elements from the DOM. ',
      'realLink' => 'detach'
    ),
    'empty' => array(
      'desc' => 'Remove all child nodes of the set of matched elements from the DOM. ',
      'realLink' => 'empty'
    ),
    'hasClass' => array(
      'desc' => 'Determine whether any of the matched elements are assigned the given class. ',
      'realLink' => 'hasClass'
    ),
    'height' => array(
      'desc' => 'Get the current computed height for the first element in the set of matched elements. ',
      'realLink' => 'height'
    ),
    'html' => array(
      'desc' => 'Get the HTML contents of the first element in the set of matched elements. ',
      'realLink' => 'html'
    ),
    'innerHeight' => array(
      'desc' => 'Get the current computed height for the first element in the set of matched elements, including padding but not border. ',
      'realLink' => 'innerHeight'
    ),
    'innerWidth' => array(
      'desc' => 'Get the current computed width for the first element in the set of matched elements, including padding but not border. ',
      'realLink' => 'innerWidth'
    ),
    'insertAfter' => array(
      'desc' => 'Insert every element in the set of matched elements after the target. ',
      'realLink' => 'insertAfter'
    ),
    'insertBefore' => array(
      'desc' => 'Insert every element in the set of matched elements before the target. ',
      'realLink' => 'insertBefore'
    ),
    'offset' => array(
      'desc' => 'Get the current coordinates of the first element in the set of matched elements, relative to the document. ',
      'realLink' => 'offset'
    ),
    'outerHeight' => array(
      'desc' => 'Get the current computed height for the first element in the set of matched elements, including padding and border. ',
      'realLink' => 'outerHeight'
    ),
    'outerWidth' => array(
      'desc' => 'Get the current computed width for the first element in the set of matched elements, including padding and border. ',
      'realLink' => 'outerWidth'
    ),
    'position' => array(
      'desc' => 'Get the current coordinates of the first element in the set of matched elements, relative to the offset parent. ',
      'realLink' => 'position'
    ),
    'prepend' => array(
      'desc' => 'Insert content, specified by the parameter, to the beginning of each element in the set of matched elements. ',
      'realLink' => 'prepend'
    ),
    'prependTo' => array(
      'desc' => 'Insert every element in the set of matched elements to the beginning of the target. ',
      'realLink' => 'prependTo'
    ),
    'remove' => array(
      'desc' => 'Remove the set of matched elements from the DOM. ',
      'realLink' => 'remove'
    ),
    'removeAttr' => array(
      'desc' => 'Remove an attribute from each element in the set of matched elements. ',
      'realLink' => 'removeAttr'
    ),
    'removeClass' => array(
      'desc' => 'Remove a single class, multiple classes, or all classes from each element in the set of matched elements. ',
      'realLink' => 'removeClass'
    ),
    'replaceAll' => array(
      'desc' => 'A selector expression indicating which element(s) to replace. ',
      'realLink' => 'replaceAll'
    ),
    'replaceWith' => array(
      'desc' => 'Replace each element in the set of matched elements with the provided new content. ',
      'realLink' => 'replaceWith'
    ),
    'scrollLeft' => array(
      'desc' => 'Get the current horizontal position of the scroll bar for the first element in the set of matched elements. ',
      'realLink' => 'scrollLeft'
    ),
    'scrollTop' => array(
      'desc' => 'Get the current vertical position of the scroll bar for the first element in the set of matched elements. ',
      'realLink' => 'scrollTop'
    ),
    'text' => array(
      'desc' => 'Get the combined text contents of each element in the set of matched elements, including their descendants. ',
      'realLink' => 'text'
    ),
    'toggleClass' => array(
      'desc' => 'Add or remove one or more classes from each element in the set of matched elements, depending on either the class\'s presence or the value of the switch argument. ',
      'realLink' => 'toggleClass'
    ),
    'unwrap' => array(
      'desc' => 'Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place. ',
      'realLink' => 'unwrap'
    ),
    'val' => array(
      'desc' => 'Get the current value of the first element in the set of matched elements. ',
      'realLink' => 'val'
    ),
    'width' => array(
      'desc' => 'Get the current computed width for the first element in the set of matched elements. ',
      'realLink' => 'width'
    ),
    'wrap' => array(
      'desc' => 'Wrap an HTML structure around each element in the set of matched elements. ',
      'realLink' => 'wrap'
    ),
    'wrapAll' => array(
      'desc' => 'Wrap an HTML structure around all elements in the set of matched elements. ',
      'realLink' => 'wrapAll'
    ),
    'wrapInner' => array(
      'desc' => 'Wrap an HTML structure around the content of each element in the set of matched elements. ',
      'realLink' => 'wrapInner'
    ),
    'unwrap' => array(
      'desc' => 'Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place. ',
      'realLink' => 'unwrap'
    )
  ),
  'miscellaneous' => array(
    'data' => array(
      'desc' => 'Store arbitrary data associated with the matched elements. ',
      'realLink' => 'data'
    ),
    'each' => array(
      'desc' => 'Iterate over a jQuery object, executing a function for each matched element. ',
      'realLink' => 'each'
    ),
    'get' => array(
      'desc' => 'Retrieve the DOM elements matched by the jQuery object. ',
      'realLink' => 'get'
    ),
    'index' => array(
      'desc' => 'Search for a given element from among the matched elements. ',
      'realLink' => 'index'
    ),
    'param' => array(
      'desc' => 'Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request. ',
      'realLink' => 'param'
    ),
    'size' => array(
      'desc' => 'Return the number of DOM elements matched by the jQuery object. ',
      'realLink' => 'size'
    ),
    'toArray' => array(
      'desc' => 'Retrieve all the DOM elements contained in the jQuery set, as an array. ',
      'realLink' => 'toArray'
    )
  ),
  'traversing' => array(
    'add' => array(
      'desc' => 'Add elements to the set of matched elements.',
      'realLink' => 'add'
    ),
    'andSelf' => array(
      'desc' => 'Add the previous set of elements on the stack to the current set.',
      'realLink' => 'andSelf'
    ),
    'children' => array(
      'desc' => 'Get the children of each element in the set of matched elements, optionally filtered by a selector.',
      'realLink' => 'children'
    ),
    'closest' => array(
      'desc' => 'Get the first element that matches the selector, beginning at the current element and progressing up through the DOM tree.',
      'realLink' => 'closest'
    ),
    'contents' => array(
      'desc' => 'Get the children of each element in the set of matched elements, including text nodes. ',
      'realLink' => 'contents'
    ),
    'each' => array(
      'desc' => 'Iterate over a jQuery object, executing a function for each matched element. ',
      'realLink' => 'each'
    ),
    'end' => array(
      'desc' => 'End the most recent filtering operation in the current chain and return the set of matched elements to its previous state.',
      'realLink' => 'end'
    ),
    'eq' => array(
      'desc' => 'Reduce the set of matched elements to the one at the specified index.',
      'realLink' => 'eq'
    ),
    'filter' => array(
      'desc' => 'Reduce the set of matched elements to those that match the selector or pass the function\'s test. ',
      'realLink' => 'filter'
    ),
    'find' => array(
      'desc' => 'Get the descendants of each element in the current set of matched elements, filtered by a selector.',
      'realLink' => 'find'
    ),
    'first' => array(
      'desc' => 'Reduce the set of matched elements to the first in the set.',
      'realLink' => 'first'
    ),
    'has' => array(
      'desc' => 'Reduce the set of matched elements to those that have a descendant that matches the selector or DOM element.',
      'realLink' => 'has'
    ),
    'is' => array(
      'desc' => 'Check the current matched set of elements against a selector and return true if at least one of these elements matches the selector.',
      'realLink' => 'is'
    ),
    'last' => array(
      'desc' => 'Reduce the set of matched elements to the final one in the set.',
      'realLink' => 'last'
    ),
    'map' => array(
      'desc' => 'Pass each element in the current matched set through a function, producing a new jQuery object containing the return values.',
      'realLink' => 'map'
    ),
    'next' => array(
      'desc' => 'Get the immediately following sibling of each element in the set of matched elements, optionally filtered by a selector.',
      'realLink' => 'next'
    ),
    'nextAll' => array(
      'desc' => 'Get all following siblings of each element in the set of matched elements, optionally filtered by a selector.',
      'realLink' => 'nextAll'
    ),
    'nextUntil' => array(
      'desc' => 'Get all following siblings of each element up to but not including the element matched by the selector.',
      'realLink' => 'nextUntil'
    ),
    'not' => array(
      'desc' => 'Remove elements from the set of matched elements.',
      'realLink' => 'not'
    ),
    'offsetParent' => array(
      'desc' => 'Get the closest ancestor element that is positioned.',
      'realLink' => 'offsetParent'
    ),
    'parent' => array(
      'desc' => 'Get the parent of each element in the current set of matched elements, optionally filtered by a selector.',
      'realLink' => 'parent'
    ),
    'parents' => array(
      'desc' => 'Get the ancestors of each element in the current set of matched elements, optionally filtered by a selector.',
      'realLink' => 'parents'
    ),
    'prev' => array(
      'desc' => 'Get the immediately preceding sibling of each element in the set of matched elements, optionally filtered by a selector.',
      'realLink' => 'prev'
    ),
    'prevAll' => array(
      'desc' => 'Get all preceding siblings of each element in the set of matched elements, optionally filtered by a selector.',
      'realLink' => 'prevAll'
    ),
    'prevUntil' => array(
      'desc' => 'Get all preceding siblings of each element up to but not including the element matched by the selector.',
      'realLink' => 'prevUntil'
    ),
    'siblings' => array(
      'desc' => 'Get the siblings of each element in the set of matched elements, optionally filtered by a selector.',
      'realLink' => 'siblings'
    ),
    'slice' => array(
      'desc' => 'Reduce the set of matched elements to a subset specified by a range of indices.',
      'realLink' => 'slice'
    )
  )
)
?>
